	//	Copyright: 	 Copyright 2004 Apple Computer, Inc. All rights reserved.
	
	//	printf("Info: ComplexPlayThru will use %ld channels\n",asbd.mChannelsPerFrame);
	//	printf("ComplexPlayThru::AudioDeviceList(bool inputs) :mInputs(inputs)\n");

	#include "AudioDeviceList.h"
	#include "AudioDevice.h"
	
	#pragma mark -
	#pragma mark === Audio DeviceList Methodes ===
//  AUDIO DEVICE LIST METHODES *****************************************************************************

	AudioDeviceList::AudioDeviceList(bool inputs) :mInputs(inputs)
	{
		printf("ComplexPlayThru::AudioDeviceList(bool inputs) :mInputs(inputs)\n");
		BuildList();
	}

	AudioDeviceList::~AudioDeviceList()
	{
		printf("ComplexPlayThru::~AudioDeviceList()\n");
	}

	void AudioDeviceList::BuildList()
	{
		printf("ComplexPlayThru::BuildList()\n");
		mDevices.clear();
	
		UInt32 propsize;
	
		verify_noerr(AudioHardwareGetPropertyInfo(kAudioHardwarePropertyDevices, &propsize, NULL));
		int nDevices = propsize / sizeof(AudioDeviceID);	
		AudioDeviceID *devids = new AudioDeviceID[nDevices];
		verify_noerr(AudioHardwareGetProperty(kAudioHardwarePropertyDevices, &propsize, devids));
	
		for (int i = 0; i < nDevices; ++i)
		{
			AudioDevice dev(devids[i], mInputs);
			if (dev.CountChannels() > 0)
			{
				Device d;
				d.mID = devids[i];
				dev.GetName(d.mName, sizeof(d.mName));
				mDevices.push_back(d);
			}
		}
		delete[] devids;
	}
